/************************* 
	Maxthon Start Page
	By Neo101
	Version 2.1.1
	30 September 2006
**************************/

var loadedConfiguration = false
var configVisible = false
var currentRowObject = null
var PLUGIN_NAME = 'MaxthonStartPage'
var TRUE = 1
var FALSE = 0
var settingsFileChecked = false

var SETTINGS_FILE = 'settings.js'



// -------------------------------------------  Show/Hide Configuration ------------------------------------------- //


function writeHTML(){
	document.getElementById('ConfigurationMain').innerHTML = getConfigHtml()
}


function getConfigHtml(){
	var data = readFile('Script/configurationMain.html')
	data = data.replace(/\r\n/g,'NEWLINE').split('<<split>>')
	var result = ''

	for(var i=0; i<data.length; i++){
		var j=0
		while(data[i].match(/\{\(.*?\)\}/) != null){
			try{
				var word = translate( data[i].match(/\{\(.*?\)\}/).toString().replace(/\{\(|\)\}/g,'') )
				data[i] = data[i].replace(/\{\((.+?)\)\}/, word)
			}
			catch(err){
				break
			}
			j++
			if(j>200) break
		}
		result += data[i].replace(/NEWLINE/g,'\r\n')
	}

	return result
}


function showConfiguration(){
	configVisible = !configVisible
	if(configVisible){ //show config
		if(!loadedConfiguration){
			writeHTML()
		}
		loadConfigurationSettings()
		setVisible('configurationMainDiv')
		document.getElementById('showConfigurationButton').innerHTML = translate('CloseConfiguration')
		for(var i=0; i<allFloatElements.length; i++){
			//if(allFloatElements[i] == 'configurationMainDiv') continue
			try{
				disableDragDrop( allFloatElements[i] )
				if(allFloatElements[i] == 'configurationDiv' || allFloatElements[i] == 'configurationMainDiv'){
					continue
				}
				setOpacity(allFloatElements[i], 20)
			}
			catch(err){}
		}
		var configElement = document.getElementById('configurationMainDiv')
		configElement.style.cursor = 'auto'
		configElement.style.zIndex = 20
		document.getElementById('configurationDiv').style.cursor = 'hand'
	}
	else{ //Hide config
		setInvisible('configurationMainDiv')
		document.getElementById('showConfigurationButton').innerHTML = translate('ShowConfiguration')
		for(var i=0; i<allFloatElements.length; i++){
			//if(allFloatElements[i] == 'configurationMainDiv') continue
			try{
				if(DISABLE_DRAG_DROP != 1) enableDragDrop( allFloatElements[i] )
				if(allFloatElements[i] == 'configurationDiv') continue
				setOpacity(allFloatElements[i], 100)
			} catch(err){}
		}
		currentRowObject = null
	}
}


// -------------------------------------------  Read/Write functions ------------------------------------------- //


function readFile(filename) {
	return external.readFile(SECURITY_ID,PLUGIN_NAME,filename)
}


function writeFile(filename,data) {
	external.writeFile(SECURITY_ID,PLUGIN_NAME,filename,data)
}


function readIni(key, errorResponse) {
	checkSettingsFile()
	if(errorResponse == null){
		errorResponse = ''
	}
	var settingsFileData = readFile(SETTINGS_FILE).split('\r\n')
	for(var i=0; i<settingsFileData.length; i++){
		if(settingsFileData[i].search(key) == 0) {
			return settingsFileData[i].replace(/.*?=/g,'')
		}
	}
	return errorResponse
}


function writeIni(key, data) {
	if(top.SECURITY_ID == null){
		alert('Can\'t Save!\nSecurityID = null')
		return
	}
	checkSettingsFile()
	
	var found = false
	var settingsFileData = readFile(SETTINGS_FILE).split('\r\n')
	for(var i=0; i<settingsFileData.length; i++){
		if(settingsFileData[i].search(key)==0) {
			if(settingsFileData[i].replace(key+'=','') == data){
				return
			}
			settingsFileData[i] = key + '=' + data
			found = true
			break
		}
	}
	settingsFileData = settingsFileData.join('\r\n')
	if(!found){ 
		settingsFileData += '\r\n' + key + '=' + data
	}
	writeFile(SETTINGS_FILE, settingsFileData)
}


function readSetting(setting){
	return readIni('var ' + setting + '( |\t)', '0')
}


function writeSetting(setting, value){
	writeIni('var '+setting+' ', ' '+value)
}


function checkSettingsFile(){
	if(settingsFileChecked == true){
		return
	}
	var settingsFile = readFile(SETTINGS_FILE)
	if(settingsFile == null || settingsFile == ''){
		var defaultSettingsFile = readFile('script/DefaultSettings.js')
		writeFile(SETTINGS_FILE, defaultSettingsFile)
	}
	settingsFileChecked = true
}

function changeArrayLanguage(){
	var element = document.getElementsByTagName('select')[0]; //Language select
	var newLanguage = element.options[element.selectedIndex].value.replace(/'/g,'')
	
	if(LANGUAGE == newLanguage){
		return
	}
	convertArrayToText('arrRSS', newLanguage)
	convertArrayToText('arrLinks', newLanguage)
	convertArrayToText('arrWeather', newLanguage)
	convertArrayToText('arrSearch', newLanguage)
}


function convertArrayToText(arrayName, language){
	var regExpString = new RegExp('.*?(var '+arrayName+'.*?\\);).*','i')

	var settingsFile = readFile(SETTINGS_FILE)
	settingsFile = settingsFile.replace(/\r\n/g,'LINEBRAKE')
	var currentArray = settingsFile.replace(regExpString,'$1')
	
	var oldLanguageFile = readFile('language/'+LANGUAGE)
	oldLanguageFile = oldLanguageFile.replace(/\r\n/g,'LINEBRAKE')
	var defaultArray = oldLanguageFile.replace(regExpString,'$1')
	
	if(unescape(defaultArray) == unescape(currentArray)){ //User did not change default settings
		var languageFile = readFile('language/'+language)
		if(languageFile == null) {
			return
		}
		languageFile = languageFile.replace(/\r\n/g,'LINEBRAKE')
		var array = languageFile.replace(regExpString,'$1')
		if(array == languageFile || array.length > 1700) { //no match
			return
		}
		saveArray(arrayName, array)
	}
}


// -------------------------------------------  Load/Save functions ------------------------------------------- //


function saveSettings()  {
	var allInputTags = document.getElementsByTagName('input');
	for(var i=0; i<allInputTags.length; i++) {
		if(allInputTags[i].type == 'checkbox') {
			if(allInputTags[i].checked == true)
				writeSetting(allInputTags[i].id+'', TRUE)
			else writeSetting(allInputTags[i].id+'', FALSE)
		}
		if(allInputTags[i].type == 'text' && allInputTags[i].className == 'config-input') 
			writeSetting(allInputTags[i].id+'', allInputTags[i].value)
	}
	
	var selectTags = document.getElementsByTagName('select');
	for(var i=0; i<selectTags.length; i++) {
		writeSetting(selectTags[i].id, selectTags[i].options[selectTags[i].selectedIndex].value)
	}
	
	saveConfigurationTables('arrLinks','importantLinksConfigTable',2)
	saveConfigurationTables('arrRSS','rssFeedsConfigTable', 3)
	saveConfigurationTables('arrSearch','searchEnginesConfigTable',2)
	saveConfigurationTables('arrWeather','AllWeatherCitiesTable',2)
	
	changeArrayLanguage()
	
	location.href = location.href //refresh
}


function loadConfigurationSettings() {
	loadedConfiguration = true
	
	writeImportantLinksConfig()
	writeRSSFeedsConfig()
	writeSearchEnginesConfig()
	writeForecastsConfig()
	
	var allInputTags = document.getElementsByTagName('input')
	for(var i=0; i<allInputTags.length; i++) {
		if(allInputTags[i].type=='checkbox') {
			if(readSetting(allInputTags[i].id+'').search(TRUE) != -1) 
				allInputTags[i].checked = true
			else allInputTags[i].checked = false
		}
		if(allInputTags[i].type == 'text' && allInputTags[i].className == 'config-input') 
			allInputTags[i].value = readSetting(allInputTags[i].id+'').replace(/ /g,'')
	}
	
	var selectTags = document.getElementsByTagName('select');
	for(var i=0; i<selectTags.length; i++) {
		var iniValue = readSetting(selectTags[i].id).replace(/;| /g,'')
		for(var j=0; j<selectTags[i].options.length; j++) {
			if(iniValue == selectTags[i].options[j].value) {
				selectTags[i].selectedIndex = j
				break
			}
		}
	}
}


function writeConfigurationTables(object){
	var output = '<table width="100%" id="'+object.tableId+'" class="config-table">'
	output += '<tr>'
	for(var i=0; i<object.numberOfCells; i++){
		output += '<th>'+object.headerTextArray[i]+'</th>'
	}	
	output+='</tr>'
	
	for(var i=0; i<object.array.length; i++){
		var element = object.array[i]
		if(element == '') break
		output += '<tr onclick="editItem(this,\''+object.tableId+'\','+object.numberOfCells+')" class=editItem>'
		if(object.array == arrWeather){
			output += '<td>'+transLocation(unescape(element[0]))+'</td>'
		}
		else{
			output += '<td>'+unescape(element[0])+'</td>'
		}
		output += '<td>'+element[1]+'</td>'
		if(object.numberOfCells == 3){
			output += '<td>'+element[2]+'</td>'
		}
		output += '</tr>'
	}
	output += '</table>'
	if(object.newButtonText != null)
		output += '<br><button onclick="editItem(0,\''+object.tableId+'\',\''+object.numberOfCells+'\')">'+object.newButtonText+'</button>'
	if(object.divId != 'AllWeatherCitiesDiv')
		output += '<button style="margin-left:100px" onclick="resetToDefault(\''+object.divId+'\')">'+translate('default')+'</button>'
	document.getElementById(object.divId).innerHTML = output
	currentlyEditing = false
	newItem = false
}


function saveConfigurationTables(arrayName, tableId, numberOfCells){
	var rows = document.getElementById(tableId).getElementsByTagName('tr')
	var newArray = 'var '+arrayName+' = new Array(\r\n'

	for(var i=0; i<rows.length; i++){
		var TDelements = rows[i].getElementsByTagName("td");
		if(TDelements.length == 0) continue
		newArray += '\tnew Array("' + escape(TDelements[0].innerText) + '","' + TDelements[1].innerText
		if(numberOfCells == 3){
			newArray += '","'+TDelements[2].innerText
		}
		newArray += '"),\r\n'
	}
	newArray += '\t""\r\n);'
	
	
	saveArray(arrayName, newArray)
}

function saveArray(arrayName, newArray){
	var regExpString = new RegExp('.*?(var '+arrayName+'.*?\\);).*','i')
	var settingsFile = readFile(SETTINGS_FILE)
	if(settingsFile == null) {
		settingsFile = readFile('settings.js')
		if(settingsFile == null){
			alert('error 215: wrong language folder. Could not save table.')
			return
		}
	}
	settingsFile = settingsFile.replace(/\r\n/g,'LINEBRAKE')
	var oldSearchArray = settingsFile.replace(regExpString,'$1')
	if(oldSearchArray != settingsFile) {
		settingsFile = settingsFile.replace(oldSearchArray, newArray)
	}
	else {
		settingsFile += 'LINEBRAKE' + newArray
	}
	settingsFile = settingsFile.replace(/LINEBRAKE/gi,'\r\n')
	
	writeFile(SETTINGS_FILE, settingsFile)
}


// -------------------------------------------  Edit Tables ------------------------------------------- //


function writeImportantLinksConfig(){
	var editObject = new EditObject(
					2, 
					new Array(translate('Name'), 'http://'), 
					new Array(translate('Name'), translate('URL')), 
					translate('addLink'),
					'importantLinksConfigTable',
					'ImportantLinksConfigurationDiv',
					arrLinks
					)
	
	writeConfigurationTables(editObject)

}


function writeRSSFeedsConfig(){
	var array = arrRSS
	if(USE_PINNED_RSS_FEED == 1){
		if(NUMBER_OF_FEEDS_START < NUMBER_OF_FEEDS){
			array = array.slice(0, NUMBER_OF_FEEDS_START)
		}
	}
	var editObject = new EditObject(
					3, 
					new Array(translate('Name'), 'http://', 'http:// '+translate('homepage')), 
					new Array(translate('Name'), translate('URL'), translate('homepage')), 
					translate('addFeed'),
					'rssFeedsConfigTable',
					'RSSFeedsConfigurationDiv',
					array
					)
	
	writeConfigurationTables(editObject)
}


function writeSearchEnginesConfig(){
	var editObject = new EditObject(
					2, 
					new Array(translate('Name'), 'http://'), 
					new Array(translate('Name'), translate('URL')), 
					translate('addEngine'),
					'searchEnginesConfigTable',
					'SearchEnginesConfigurationDiv',
					arrSearch
					)
	
	writeConfigurationTables(editObject)
}


function writeForecastsConfig(){
	var editObject = new EditObject(
					2, 
					new Array(), 
					new Array(translate('cityName'), translate('cityCode')), 
					null,
					'AllWeatherCitiesTable',
					'AllWeatherCitiesDiv',
					arrWeather
					)
	
	writeConfigurationTables(editObject)
}


function EditObject(numberOfCells, defaultTextArray, headerTextArray, newButtonText, tableId, divId, array){
	this.numberOfCells = numberOfCells
	this.defaultTextArray = defaultTextArray
	this.headerTextArray = headerTextArray
	this.newButtonText = newButtonText
	this.tableId = tableId
	this.divId = divId
	this.array = array
}


function EditRowObject(rowElement, tableElement, numberOfCells){
	this.rowElement = rowElement
	this.tdBackup = new Array()
	for(var i=0; i<numberOfCells; i++){
		this.tdBackup[i] = rowElement.childNodes(i).innerHTML
	}
	this.tableElement = tableElement
	this.numberOfCells = numberOfCells
}


function createnewTableRow(tableName, numberOfCells){
	var newTableRow = document.getElementById(tableName).insertRow()
	newTableRow.insertCell().innerHTML = ''
	newTableRow.insertCell().innerHTML = ''
	
	if(numberOfCells == 3){
		newTableRow.insertCell().innerHTML = ''
	}
	newItem = true
	return newTableRow
}


function editItem(rowElement, tableName, numberOfCells){
	if(currentRowObject != null) return
	if(rowElement == 0){
		rowElement = createnewTableRow(tableName, numberOfCells)
	}
	currentRowObject = new EditRowObject(rowElement, rowElement.parentElement, numberOfCells)

	rowElement.style.cursor = 'auto'
	var TDelements = rowElement.getElementsByTagName("td")

	for(var i=0; i<numberOfCells; i++){
		TDelements[i].innerHTML = '<input type="text" id="editItem'+(i+1)+'" value="'+TDelements[i].innerHTML+'" />'
	}
	
	var newTableRow = rowElement.parentElement.insertRow(rowElement.rowIndex+1)
	var newTableRowHTML = '<div>'+
							'<button onclick="saveItem()" style="width:80px">'+translate('save')+'</button>&nbsp;&nbsp;&nbsp;'+
							'<button onclick="cancelItem()">'+translate('cancel')+'</button>'
	if(!newItem){
		newTableRowHTML += '<button style="margin-left:50px;" onclick="deleteItem()">'+translate('delete')+'</button>'
	}
	newTableRowHTML += '</div>'
	var newTableCell = newTableRow.insertCell()
	newTableCell.colSpan = 2
	newTableCell.innerHTML = newTableRowHTML
}


function resetToDefault(tableName){
	var functionName = 'write' + tableName.replace(/urationDiv/,'')+'()'
	var arrays = {'writeImportantLinksConfig()':'arrLinks','writeRSSFeedsConfig()':'arrRSS','writeSearchEnginesConfig()':'arrSearch'}
	
	var arrayName = arrays[functionName]

	var confirmation = confirm( translate('confirmReset') )
	if(confirmation == true){
		var regExpString = new RegExp('.*?(var '+arrayName+'.*?\\);).*','i')
		var oldLanguageFile = readFile('language/'+LANGUAGE)
		oldLanguageFile = oldLanguageFile.replace(/\r\n/g,'LINEBRAKE')
		var defaultArray = oldLanguageFile.replace(regExpString,'$1')
		defaultArray = defaultArray.replace(/LINEBRAKE/g,'\r\n').replace(/var /,'')
		eval(defaultArray)
		eval( functionName )
	}
	
}


function cancelItem(){
	if(currentRowObject == null){
		return
	}
	var TDelements = currentRowObject.rowElement.getElementsByTagName("td")
	var rowElement = currentRowObject.rowElement
	for(var i=0; i<currentRowObject.numberOfCells; i++){
		TDelements[i].innerHTML = currentRowObject.tdBackup[i]
	}
	currentRowObject.tableElement.deleteRow(rowElement.rowIndex+1)
	rowElement.style.cursor = "pointer"
	if(newItem){
		rowElement.removeNode(true)
		newItem = false
	}
	currentRowObject = null
}


function saveItem(){
	if(currentRowObject == null){
		return
	}
	var rowElement = currentRowObject.rowElement
	var TDelements=rowElement.getElementsByTagName("td")
	if(document.getElementById('editItem1').value == '' || document.getElementById('editItem2').value == ''){
		alert( translate('insertValue') )
		return
	}
	for(var i=0; i<currentRowObject.numberOfCells; i++){
		TDelements[i].innerHTML = document.getElementById('editItem'+(i+1)).value
	}

	currentRowObject.tableElement.deleteRow(rowElement.rowIndex+1)
	if(newItem){
		rowElement.onclick=function(){
									editItem(this)
								}
	}
	rowElement.style.cursor = "pointer"
	newItem = false
	currentlyEditing = false
	currentRowObject = null
}


function deleteItem(){
	if(currentRowObject == null){
		return
	}
	var rowElement = currentRowObject.rowElement
	currentRowObject.tableElement.deleteRow(rowElement.rowIndex+1)
	rowElement.removeNode(true)
	currentlyEditing = false
	currentRowObject = null
}


function expandCollapse(element){
	if(element.style.display == 'none')
		element.style.display = ''
	else 
		element.style.display = 'none'
}

// -------------------------------------------  Search for new weather location ------------------------------------------- //


function enterKeyPress() {
	if (window.event.keyCode == 13){
		findlocationId()
	}
}


function clearRows() {
	var rowsLength = resultcontent.rows.length
	for(var i=0; i<rowsLength; i++) 
		resultcontent.deleteRow()
		
	confirmButton.style.display = 'none'
	cityInfo.innerHTML = ''
}


function addRow(rowHTML) {
	var newRow = resultcontent.insertRow()
	var newCell= resultcontent.rows(newRow.rowIndex).insertCell()
	newCell.innerHTML = rowHTML
}


function findlocationId() {
	var name = citySearch.value
	if(name.search(/[a-zA-Z]{4}[0-9]{4}/)!=-1) {
		saveWeatherCity(name, 'Unknown')
		return
	} else if(name=='') {
		clearRows()
		addRow( translate('NoKeywords') )
		return
	}
	name = transCity( name.toLowerCase() )
	var WEBPAGE_LOCATION_SEARCH = 'http://xml.weather.com/search/search?where='
	var scriptURL = WEBPAGE_LOCATION_SEARCH + name
	retrieveHTMLSearch(scriptURL)
}


function retrieveHTMLSearch(url) {
	try{
		try{
			xmlObject = external.max_activex(SECURITY_ID, "Microsoft.XMLDOM")
		}
		catch(err) {
			xmlObject = new ActiveXObject("Microsoft.XMLDOM")
		}
		xmlObject.onreadystatechange = readyStateChangeSearch
		xmlObject.load(url);
	} catch(err){
		evaluateSearch(0) 
	}
}


function readyStateChangeSearch() {
	if(xmlObject && xmlObject.readyState==4) {
		if(xmlObject.xml)
			evaluateSearch(xmlObject.xml)
		else
			evaluateSearch(0)
	}
}


function evaluateSearch(dataall,x){
	if(dataall == 0) {
		clearRows()
		addRow( translate('ConnectionError') )	
		return
	}
	citiesArray = xmlParse(dataall)
	if(citiesArray.length == 0 || citiesArray[0][0].search(/location provided|unknown error/i) != -1) {
		clearRows()
		addRow( translate('NoResult') )		
	} else {
		clearRows()
		cityInfo.innerHTML = '<b>'+translate('found')+' '+citiesArray.length+' '+translate('Cities')+'</b>'
		for(var i=0; i<citiesArray.length; i++) {
			rowHTML = '<input type=radio '+((citiesArray.length==1)?'checked':'')+
						' id=list'+i+' name=listcities value='+citiesArray[i][1]+'>'+
					'<label for=list'+i+'>&nbsp;'+transLocation( citiesArray[i][0] )+'</label>'
			addRow(rowHTML)			
		}
		confirmButton.style.display = 'block'
	}
}


function xmlParse(xmlText) {
	var nodes = new Array()
	var elements = xmlObject.documentElement.childNodes
	for(var i=0; i<elements.length; i++){
		nodes[i] 	= new Array()
		nodes[i][0] = elements.item(i).text
		nodes[i][1] = elements.item(i).getAttribute("id") 
	}
	return nodes
}


function confirmcity() {
	var set = false
	if(citiesArray.length == 1 && listcities.checked) {
		saveLocation(0)
		set = true
	} else if(citiesArray.length>1){
		for(var i=0; i<citiesArray.length; i++) {
			if(listcities[i].checked) {
				saveLocation(i)
				set = true
				break
			}
		}
	}
	if(set == 1) {
		document.getElementById('citySearch').value = ''
		clearRows()
		addRow( '<b>'+translate('Saved')+'</b>' )
	}
}


function saveLocation(i){
	saveWeatherCity(citiesArray[i][1], citiesArray[i][0])
}


function saveWeatherCity(cityId, cityName){
	editItem(0, 'AllWeatherCitiesTable', 2)
	document.getElementById('editItem1').value = cityName
	document.getElementById('editItem2').value = cityId
	saveItem()
}


function transCity(city){
	var city = city.toLowerCase()
	for( i in language){
		if(language[i].toLowerCase() == city){
			return i
		}
	}
	return city
}
